<template>
  <div>
    <h2 id="page-heading" data-cy="AdherenciaHeading">
      <span v-text="$t('gatewayApp.pacientesAdherencia.home.title')" id="adherencia-heading">Adherencias</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.pacientesAdherencia.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'AdherenciaCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-adherencia"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.pacientesAdherencia.home.createLabel')"> Create a new Adherencia </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && adherencias && adherencias.length === 0">
      <span v-text="$t('gatewayApp.pacientesAdherencia.home.notFound')">No adherencias found</span>
    </div>
    <div class="table-responsive" v-if="adherencias && adherencias.length > 0">
      <table class="table table-striped" aria-describedby="adherencias">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('horaToma')">
              <span v-text="$t('gatewayApp.pacientesAdherencia.horaToma')">Hora Toma</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'horaToma'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('respuesta')">
              <span v-text="$t('gatewayApp.pacientesAdherencia.respuesta')">Respuesta</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'respuesta'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('valor')">
              <span v-text="$t('gatewayApp.pacientesAdherencia.valor')">Valor</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'valor'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('comentario')">
              <span v-text="$t('gatewayApp.pacientesAdherencia.comentario')">Comentario</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'comentario'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('medicamento.nombre')">
              <span v-text="$t('gatewayApp.pacientesAdherencia.medicamento')">Medicamento</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'medicamento.nombre'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('paciente.nombre')">
              <span v-text="$t('gatewayApp.pacientesAdherencia.paciente')">Paciente</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'paciente.nombre'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="adherencia in adherencias" :key="adherencia.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'AdherenciaView', params: { adherenciaId: adherencia.id } }">{{ adherencia.id }}</router-link>
            </td>
            <td>{{ adherencia.horaToma ? $d(Date.parse(adherencia.horaToma), 'short') : '' }}</td>
            <td>{{ adherencia.respuesta }}</td>
            <td>{{ adherencia.valor }}</td>
            <td>{{ adherencia.comentario }}</td>
            <td>
              <div v-if="adherencia.medicamento">
                <router-link :to="{ name: 'MedicamentoView', params: { medicamentoId: adherencia.medicamento.id } }">{{
                  adherencia.medicamento.nombre
                }}</router-link>
              </div>
            </td>
            <td>
              <div v-if="adherencia.paciente">
                <router-link :to="{ name: 'PacienteView', params: { pacienteId: adherencia.paciente.id } }">{{
                  adherencia.paciente.nombre
                }}</router-link>
              </div>
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'AdherenciaView', params: { adherenciaId: adherencia.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'AdherenciaEdit', params: { adherenciaId: adherencia.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(adherencia)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span
          id="gatewayApp.pacientesAdherencia.delete.question"
          data-cy="adherenciaDeleteDialogHeading"
          v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-adherencia-heading" v-text="$t('gatewayApp.pacientesAdherencia.delete.question', { id: removeId })">
          Are you sure you want to delete this Adherencia?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-adherencia"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeAdherencia()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./adherencia.component.ts"></script>
